%
% Decentralized Reconstruction from Compressive Random Projections
% Driven by Principal Components
% Copyright (C) 2014-2015  James E. Fowler
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%

function [X_hat, Psi] = Centralized_Decoder(Y_tilde, P, L)

M = length(P);
[N K] = size(P{1});

X_hat = zeros(N, M);

Psi = zeros(N, L);

Y_tilde2 = Y_tilde;

for l = 1:L

  Sigma_hat = zeros(N, N);

  for m = 1:M
    x_hat = P{m} * Y_tilde2(:, m);
    Sigma_hat = Sigma_hat + x_hat * x_hat' / M;
  end
  
  [Psi(:, l) lambda] = eigs(Sigma_hat, 1);

  for m = 1:M
    X_hat(:, m) = Psi * pinv(P{m}' * Psi) * Y_tilde(:, m); 
    Y_tilde2(:, m) = Y_tilde(:, m) - P{m}' * X_hat(:, m);
  end

end

  
