%
% Decentralized Reconstruction from Compressive Random Projections
% Driven by Principal Components
% Copyright (C) 2014-2015  James E. Fowler
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%

function run_make_graph()

% M = number of nodes in graph
M = 10000;

expected_node_degree = 3;

disp('Generating random graph...');
tic
Graph_L = GenerateRandomGraph(M, expected_node_degree);
toc
disp('Generating weight matrix...');
tic
Graph_W = GenerateWeightMatrix(Graph_L, 'localdegree');
toc

save(['random_graph.' num2str(M) '.' ...
      num2str(expected_node_degree) '.mat'], ...
    'Graph_W', 'Graph_L', 'M');
